//+------------------------------------------------------------------+
//|                                                          ZZP.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, TheXpert"
#property link      "theforexpert@gmail.com"

//#property indicator_separate_window
#property indicator_chart_window
#property indicator_buffers 5

#property indicator_color1 LightGray
#property indicator_color2 LightGray

#define UP 0.0001
#define DN -0.0001
#define NONE 0

extern double ChannelPercent = 0.08;

// attention! when used, this option can lead to incorrect visualization of last ZZ ray at 0 bar
// incorrect visualization will be redrawn when new bar appears
// use it carefully and don't expect complete correctness
// never(!) use this indicator values from 0 bar in your automated strategies.


// never(!) use this option if this indicator is used in automated strategy.
// if used, this option can lead to incorrect extremum parsing in your EA

/* extern */ bool DrawZeroBar = false;



extern int BarsHistory=1000;
extern bool Draw_HH.LL=true;
extern int LineTick_HH.LL=2;
extern int font_HH.LL=9;
extern color color_HH.LL=Red;

extern bool Draw_HH.HL=true;
extern int LineTick_HH.HL=2;
extern int font_HH.HL=9;
extern color color_HH.HL=Blue;

extern bool Draw_LH.LL=true;
extern int LineTick_LH.LL=2;
extern int font_LH.LL=9;
extern color color_LH.LL=Orange;

extern bool Draw_LH.HL=true;
extern int LineTick_LH.HL=2;
extern int font_LH.HL=9;
extern color color_LH.HL=Yellow;

extern bool Draw_LL.HH=true;
extern int LineTick_LL.HH=2;
extern int font_LL.HH=9;
extern color color_LL.HH=Green;

extern bool Draw_LL.LH=true;
extern int LineTick_LL.LH=2;
extern int font_LL.LH=9;
extern color color_LL.LH=White;

extern bool Draw_HL.HH=true;
extern int LineTick_HL.HH=2;
extern int font_HL.HH=9;
extern color color_HL.HH=Aqua;

extern bool Draw_HL.LH=true;
extern int LineTick_HL.LH=2;
extern int font_HL.LH=9;
extern color color_HL.LH=Gold;

extern color HH_Color=Blue;
extern color LH_Color=Aqua;
extern color LL_Color=Red;
extern color HL_Color=Orange;
extern int TextShift=5;
extern int MA_AngleTextShift=14;

extern bool Alert_HH.LL=false;
extern bool Alert_HH.LL.HH=false;
extern bool Alert_LL.HH=false;
extern bool Alert_LL.HH.LL=false;
double Maxs[];
double Mins[];
double LastType[2][3];
double Direction[];

double MaxTime[];
double MinTime[];

string symbol;
double newHigh,newLow;
int highbar,lowbar;
double LastHigh;
double LastLow;

datetime LastAlertSignal;
datetime LastAlertSignal2;
datetime T;
datetime LastTime;

bool Inited;
int Number;
bool initialized;

int Q;
bool StartAlert;
//-----------------------------------------------------------------+
int init()
{
   if(Digits==5||Digits==3)Q=10;
   else Q=1;
   SetIndexBuffer(0, Maxs);
   SetIndexBuffer(1, Mins);
   
   SetIndexBuffer(2, MinTime);
   SetIndexBuffer(3, MaxTime);
   
   SetIndexBuffer(4, Direction);

   SetIndexStyle(0, DRAW_ZIGZAG);
   SetIndexStyle(1, DRAW_ZIGZAG);

   SetIndexStyle(2, DRAW_NONE);
   SetIndexStyle(3, DRAW_NONE);
   SetIndexStyle(4, DRAW_NONE);

   symbol = Symbol();
   
   IndicatorDigits(Digits);

   Inited = false;
   LastTime = 0;
   
   return(0);
}

//-----------------------------------------------------------------+
int deinit()
 {
  ObjectsDeleteAll(0,OBJ_TREND);
  ObjectsDeleteAll(0,OBJ_TEXT);
 }
//-----------------------------------------------------------------+   
int start()
{
   if (!Inited)
   {
      ArrayInitialize(Mins, EMPTY_VALUE);
      ArrayInitialize(Maxs, EMPTY_VALUE);
      ArrayInitialize(MinTime, EMPTY_VALUE);
      ArrayInitialize(MaxTime, EMPTY_VALUE);
      ArrayInitialize(Direction, EMPTY_VALUE);
   }
   
   int ToCount = Bars - IndicatorCounted();
   
   // DON'T fix to >= 0. For the 0 bar the logic is in DrawZeroBar block
   for (int i = ToCount - 1; i > 0; i--)
   {
      if (i < Bars - 1)
      {
         MinTime[i] = MinTime[i + 1];
         MaxTime[i] = MaxTime[i + 1];
         Direction[i] = Direction[i + 1];
         Maxs[i] = EMPTY_VALUE;
         Mins[i] = EMPTY_VALUE;
      }
      
      Check(i);
   }
   
   if (DrawZeroBar)
   {
      if (LastTime != Time[0])
      {
         LastTime = Time[0];

         MinTime[0] = MinTime[1];
         MaxTime[0] = MaxTime[1];
         Direction[0] = Direction[1];
         Maxs[0] = EMPTY_VALUE;
         Mins[0] = EMPTY_VALUE;
      }
      
      CheckPrice(0, Close[0]);
   }
   else
   {
      Maxs[0] = EMPTY_VALUE;
      Mins[0] = EMPTY_VALUE;
   }
   string LastDrawn;
   double PreviousLow,PreviousHigh;
   int n,k,m,pr_lowbar,pr_highbar;
   static string LastObjectName;
    Number=0;
  
   if(T==Time[0])return;
   T=Time[0];
   
 int NH,NL,TimeHigh,TimeLow; 
 int cnt;
 for(cnt=1;cnt<Bars;cnt++){
  if(Maxs[cnt]==High[cnt]){
   LastType[0][NH]=Maxs[cnt];
   if(NH==3)continue;
   NH++;
   if(NH==1)TimeHigh=Time[cnt];
  }
  if(Mins[cnt]==Low[cnt]){
   LastType[1][NL]=Mins[cnt];
   if(NL==3)continue;
   NL++; 
   if(NL==1)TimeLow=Time[cnt]; 
  }
  if(NH>=3&&NL>=3)break;
 }
 

  if(LastType[0][0]>LastType[0][1]&&LastType[1][0]<LastType[1][1]&&TimeHigh+TimeLow!=LastAlertSignal){
  
   if(LastType[0][1]>LastType[0][2]&&Alert_HH.LL.HH&&LastSignalType(0)==-1)
    Alert("HH.LL.HH sequence  "+Symbol()+" TF: "+Period());
   else if(Alert_HH.LL&&LastSignalType(0)==1) Alert("HH.LL Segment  "+Symbol()+" TF: "+Period());
    LastAlertSignal=TimeHigh+TimeLow; Print("alert");
 }
  if(LastType[1][0]<LastType[1][1]&&LastType[0][0]>LastType[0][1]&&TimeHigh+TimeLow!=LastAlertSignal2){
  
   if(LastType[1][1]<LastType[1][2]&&Alert_LL.HH.LL&&LastSignalType(0)==1)
    Alert("LL.HH.LL sequence  "+Symbol()+" TF: "+Period());
    else if(Alert_LL.HH&&LastSignalType(0)==-1) Alert("LL.HH Segment  "+Symbol()+" TF: "+Period());
    LastAlertSignal2=TimeHigh+TimeLow;
 }

      ObjectsDeleteAll(0,OBJ_TEXT);
       ObjectsDeleteAll(0,OBJ_TREND);

   for(int j=1;j<=BarsHistory;j++){
     
    if(Maxs[j]!=High[j]&&Mins[j]!=Low[j])continue;
     
    if(Maxs[j]==High[j]&&LastSignalType(j)==-1||Mins[j]!=Low[j]){
     newHigh=Maxs[j];
     highbar=j;
     PreviousLow=0;
     newLow=0;
     PreviousHigh=0;
     for( n=highbar;n<Bars;n++){
     if(Mins[n]==Low[n]&&newLow!=0){
       PreviousLow=Mins[n];
        pr_lowbar=n;
      }
      if(Mins[n]==Low[n]&&newLow==0){
       newLow=Mins[n];
       lowbar=n;
      }
      if(Maxs[n+1]==High[n+1]&&PreviousHigh==0){
       PreviousHigh=Maxs[n+1];
       pr_highbar=n+1;
      }
      if(PreviousLow!=0)break;
     } 
    
     
    if(newHigh>PreviousHigh&&newLow<PreviousLow&&Draw_LL.HH){
   
     drawtrend("LL.HH"+Number,Time[highbar],newHigh,Time[lowbar],newLow,color_LL.HH,LineTick_LL.HH);
     drawtext("LL"+Number,"LL ",LL_Color,Time[lowbar],newLow-TextShift*Point*Q,font_LL.HH);
     drawtext("HH"+Number,"HH ",HH_Color,Time[highbar],newHigh+TextShift*Point*Q,font_LL.HH);
     drawtext("LLM"+Number,DoubleToStr(Ma_Angle(lowbar),2),LL_Color,Time[lowbar],newLow-MA_AngleTextShift*Point*Q,font_LL.HH);
     drawtext("HHM"+Number,DoubleToStr(Ma_Angle(highbar),2),HH_Color,Time[highbar],newHigh+MA_AngleTextShift*Point*Q,font_LL.HH);
      }
   
    if(newHigh<PreviousHigh&&newLow<PreviousLow&&Draw_LL.LH)
{
    drawtrend("LL.LH"+Number,Time[highbar],newHigh,Time[lowbar],newLow,color_LL.LH,LineTick_LL.LH);
    drawtext("LL"+Number,"LL",LL_Color,Time[lowbar],newLow-TextShift*Point*Q,font_LL.LH);
    drawtext("LH"+Number,"LH",LH_Color,Time[highbar],newHigh+TextShift*Point*Q,font_LL.LH);
    drawtext("LLM"+Number,DoubleToStr(Ma_Angle(lowbar),2),LL_Color,Time[lowbar],newLow-MA_AngleTextShift*Point*Q,font_LL.LH);
    drawtext("LHM"+Number,DoubleToStr(Ma_Angle(highbar),2),LH_Color,Time[highbar],newHigh+MA_AngleTextShift*Point*Q,font_LL.LH);
     
    }
     
    if(newHigh>PreviousHigh&&newLow>PreviousLow&&Draw_HL.HH){
     
     drawtrend("HL.HH"+Number,Time[highbar],newHigh,Time[lowbar],newLow,color_HL.HH,LineTick_HL.HH);
     drawtext("HL"+Number,"HL",HL_Color,Time[lowbar],newLow-TextShift*Point*Q,font_HL.HH);
     drawtext("HH"+Number,"HH",HH_Color,Time[highbar],newHigh+TextShift*Point*Q,font_HL.HH);
     drawtext("HLM"+Number,DoubleToStr(Ma_Angle(lowbar),2),HL_Color,Time[lowbar],newLow-MA_AngleTextShift*Point*Q,font_HL.HH);
     drawtext("HHM"+Number,DoubleToStr(Ma_Angle(highbar),2),HH_Color,Time[highbar],newHigh+MA_AngleTextShift*Point*Q,font_HL.HH);
     }
    if(newHigh<PreviousHigh&&newLow>PreviousLow&&Draw_HL.LH){
    
     drawtrend("HL.LH"+Number,Time[highbar],newHigh,Time[lowbar],newLow,color_HL.LH,LineTick_HL.LH);
     drawtext("HL"+Number,"HL",HL_Color,Time[lowbar],newLow-TextShift*Point*Q,font_HL.LH);
     drawtext("LH"+Number,"LH",LH_Color,Time[highbar],newHigh+TextShift*Point*Q,font_HL.LH);
     drawtext("HLM"+Number,DoubleToStr(Ma_Angle(lowbar),2),HL_Color,Time[lowbar],newLow-MA_AngleTextShift*Point*Q,font_HL.LH);
     drawtext("LHM"+Number,DoubleToStr(Ma_Angle(highbar),2),LH_Color,Time[highbar],newHigh+MA_AngleTextShift*Point*Q,font_HL.LH);
     }
   }
     if(Mins[j]==Low[j]&&LastSignalType(j)==1||Maxs[j]!=High[j]){
     newLow=Mins[j];
     lowbar=j;
     PreviousLow=0;
     newHigh=0;
     PreviousHigh=0;
     
     for( n=lowbar;n<Bars;n++){
     
     if(Maxs[n]==High[n]&&newHigh!=0){
       PreviousHigh=Maxs[n];
       pr_highbar=n;
      }
      if(Maxs[n]==High[n]&&newHigh==0){
       newHigh=Maxs[n];
       highbar=n;
      }
      if(Mins[n+1]==Low[n+1]&&PreviousLow==0){
       PreviousLow=Mins[n+1];
       pr_lowbar=n+1;
      }
      if(PreviousHigh!=0)break;
     } 
     
   if(newHigh>PreviousHigh&&newLow>PreviousLow&&Draw_HH.HL){
   
    drawtrend("HH.HL"+Number,Time[highbar],newHigh,Time[lowbar],newLow,color_HH.HL,LineTick_HH.HL);
    drawtext("HL"+Number,"HL",HL_Color,Time[lowbar],newLow-TextShift*Point*Q,font_HH.HL);
    drawtext("HH"+Number,"HH",HH_Color,Time[highbar],newHigh+TextShift*Point*Q,font_HH.HL);
    drawtext("HLM"+Number,DoubleToStr(Ma_Angle(lowbar),2),HL_Color,Time[lowbar],newLow-MA_AngleTextShift*Point*Q,font_HH.HL);
    drawtext("HHM"+Number,DoubleToStr(Ma_Angle(highbar),2),HH_Color,Time[highbar],newHigh+MA_AngleTextShift*Point*Q,font_HH.HL);
       }
   if(newHigh>PreviousHigh&&newLow<PreviousLow&&Draw_HH.LL){
    
    drawtrend("HH.LL"+Number,Time[highbar],newHigh,Time[lowbar],newLow,color_HH.LL,LineTick_HH.LL);
    drawtext("LL"+Number,"LL",LL_Color,Time[lowbar],newLow-TextShift*Point*Q,font_HH.LL);
    drawtext("HH"+Number,"HH",HH_Color,Time[highbar],newHigh+TextShift*Point*Q,font_HH.LL);
    drawtext("LLM"+Number,DoubleToStr(Ma_Angle(lowbar),2),LL_Color,Time[lowbar],newLow-MA_AngleTextShift*Point*Q,font_HH.LL);
    drawtext("HHM"+Number,DoubleToStr(Ma_Angle(highbar),2),HH_Color,Time[highbar],newHigh+MA_AngleTextShift*Point*Q,font_HH.LL);
    }
   if(newHigh<PreviousHigh&&newLow<PreviousLow&&Draw_LH.LL){
    
    drawtrend("LH.LL"+Number,Time[highbar],newHigh,Time[lowbar],newLow,color_LH.LL,LineTick_LH.LL);
    drawtext("LL"+Number,"LL",LL_Color,Time[lowbar],newLow-TextShift*Point*Q,font_LH.LL);
     drawtext("LH"+Number,"LH",LH_Color,Time[highbar],newHigh+TextShift*Point*Q,font_LH.LL);
       drawtext("LLM"+Number,DoubleToStr(Ma_Angle(lowbar),2),LL_Color,Time[lowbar],newLow-MA_AngleTextShift*Point*Q,font_LH.LL);
     drawtext("LHM"+Number,DoubleToStr(Ma_Angle(highbar),2),LH_Color,Time[highbar],newHigh+MA_AngleTextShift*Point*Q,font_LH.LL);
     }
    if(newHigh<PreviousHigh&&newLow>PreviousLow&&Draw_LH.HL){
    
    drawtrend("LH.HL"+Number,Time[highbar],newHigh,Time[lowbar],newLow,color_LH.HL,LineTick_LH.HL);
    drawtext("LH"+Number,"LH",LH_Color,Time[highbar],newHigh+TextShift*Point*Q,font_LH.HL);
     drawtext("HL"+Number,"HL",HL_Color,Time[lowbar],newLow-TextShift*Point*Q,font_LH.HL);
      drawtext("LHM"+Number,DoubleToStr(Ma_Angle(highbar),2),LH_Color,Time[highbar],newHigh+MA_AngleTextShift*Point*Q,font_LH.HL);
     drawtext("HLM"+Number,DoubleToStr(Ma_Angle(lowbar),2),HL_Color,Time[lowbar],newLow-MA_AngleTextShift*Point*Q,font_LH.HL);
       }
   }
   
    if(Mins[j]==Low[j]&&Maxs[j]==High[j]&&LastSignalType(j)==-1){
      for(m=pr_highbar+1;m<Bars;m++){
      if(Maxs[m]==High[m]){
       newHigh=PreviousHigh;
       PreviousHigh=Maxs[m];
       break;
      }
     }
      if(newHigh>PreviousHigh&&newLow>PreviousLow&&Draw_HH.HL){
     
    drawtrend("HH.HL"+Number,Time[pr_highbar],newHigh,Time[lowbar],newLow,color_HH.HL,LineTick_HH.HL);
    drawtext("HL"+Number,"HL",HL_Color,Time[lowbar],newLow-TextShift*Point*Q,font_HH.HL);
    drawtext("HH"+Number,"HH",HH_Color,Time[pr_highbar],newHigh+TextShift*Point*Q,font_HH.HL);
     drawtext("HLM"+Number,DoubleToStr(Ma_Angle(lowbar),2),HL_Color,Time[lowbar],newLow-MA_AngleTextShift*Point*Q,font_HH.HL);
    drawtext("HHM"+Number,DoubleToStr(Ma_Angle(pr_highbar),2),HH_Color,Time[pr_highbar],newHigh+MA_AngleTextShift*Point*Q,font_HH.HL);
    }
   if(newHigh>PreviousHigh&&newLow<PreviousLow&&Draw_HH.LL){
    
    drawtrend("HH.LL"+Number,Time[pr_highbar],newHigh,Time[lowbar],newLow,color_HH.LL,LineTick_HH.LL);
    drawtext("LL"+Number,"LL",LL_Color,Time[lowbar],newLow-TextShift*Point*Q,font_HH.LL);
     drawtext("HH"+Number,"HH",HH_Color,Time[pr_highbar],newHigh+TextShift*Point*Q,font_HH.LL);
     drawtext("LLM"+Number,DoubleToStr(Ma_Angle(lowbar),2),LL_Color,Time[lowbar],newLow-MA_AngleTextShift*Point*Q,font_HH.LL);
     drawtext("HHM"+Number,DoubleToStr(Ma_Angle(pr_highbar),2),HH_Color,Time[pr_highbar],newHigh+MA_AngleTextShift*Point*Q,font_HH.LL);
       }
   if(newHigh<PreviousHigh&&newLow<PreviousLow&&Draw_LH.LL){
   
    drawtrend("LH.LL"+Number,Time[pr_highbar],newHigh,Time[lowbar],newLow,color_LH.LL,LineTick_LH.LL);
    drawtext("LL"+Number,"LL",LL_Color,Time[lowbar],newLow-TextShift*Point*Q,font_LH.LL);
     drawtext("LH"+Number,"LH",LH_Color,Time[pr_highbar],newHigh+TextShift*Point*Q,font_LH.LL);
     drawtext("LLM"+Number,DoubleToStr(Ma_Angle(lowbar),2),LL_Color,Time[lowbar],newLow-MA_AngleTextShift*Point*Q,font_LH.LL);
     drawtext("LHM"+Number,DoubleToStr(Ma_Angle(pr_highbar),2),LH_Color,Time[pr_highbar],newHigh+MA_AngleTextShift*Point*Q,font_LH.LL);
    }
    if(newHigh<PreviousHigh&&newLow>PreviousLow&&Draw_LH.HL){
     
    drawtrend("LH.HL"+Number,Time[pr_highbar],newHigh,Time[lowbar],newLow,color_LH.HL,LineTick_LH.HL);
     drawtext("LH"+Number,"LH",LH_Color,Time[pr_highbar],newHigh+TextShift*Point*Q,font_LH.HL);
     drawtext("HL"+Number,"HL",HL_Color,Time[lowbar],newLow-TextShift*Point*Q,font_LH.HL);
     drawtext("LHM"+Number,DoubleToStr(Ma_Angle(pr_highbar),2),LH_Color,Time[pr_highbar],newHigh+MA_AngleTextShift*Point*Q,font_LH.HL);
     drawtext("HLM"+Number,DoubleToStr(Ma_Angle(lowbar),2),HL_Color,Time[lowbar],newLow-MA_AngleTextShift*Point*Q,font_LH.HL);
       }
   }
    if(Mins[j]==Low[j]&&Maxs[j]==High[j]&&LastSignalType(j)==1){
     for(m=pr_lowbar+1;m<Bars;m++){
      if(Mins[m]==Low[m]){
       newLow=PreviousLow;
       PreviousLow=Mins[m];
       break;
      }
     }
    if(newHigh>PreviousHigh&&newLow<PreviousLow&&Draw_LL.HH){
     
     drawtrend("LL.HH"+Number,Time[highbar],newHigh,Time[pr_lowbar],newLow,color_LL.HH,LineTick_LL.HH);
     drawtext("LL"+Number,"LL",LL_Color,Time[pr_lowbar],newLow-TextShift*Point*Q,font_LL.HH);
      drawtext("HH"+Number,"HH",HH_Color,Time[highbar],newHigh+TextShift*Point*Q,font_LL.HH);
       drawtext("LLM"+Number,DoubleToStr(Ma_Angle(pr_lowbar),2),LL_Color,Time[pr_lowbar],newLow-MA_AngleTextShift*Point*Q,font_LL.HH);
      drawtext("HHM"+Number,DoubleToStr(Ma_Angle(highbar),2),HH_Color,Time[highbar],newHigh+MA_AngleTextShift*Point*Q,font_LL.HH);
       }
    if(newHigh<PreviousHigh&&newLow<PreviousLow&&Draw_LL.LH){
      
    drawtrend("LL.LH"+Number,Time[highbar],newHigh,Time[pr_lowbar],newLow,color_LL.LH,LineTick_LL.LH);
     drawtext("LL"+Number,"LL",LL_Color,Time[pr_lowbar],newLow-TextShift*Point*Q,font_LL.LH);
    drawtext("LH"+Number,"LH",LH_Color,Time[highbar],newHigh+TextShift*Point*Q,font_LL.LH);
      drawtext("LLM"+Number,DoubleToStr(Ma_Angle(pr_lowbar),2),LL_Color,Time[pr_lowbar],newLow-MA_AngleTextShift*Point*Q,font_LL.LH);
    drawtext("LHM"+Number,DoubleToStr(Ma_Angle(highbar),2),LH_Color,Time[highbar],newHigh+MA_AngleTextShift*Point*Q,font_LL.LH);
      }
    if(newHigh>PreviousHigh&&newLow>PreviousLow&&Draw_HL.HH){
    
     drawtrend("HL.HH"+Number,Time[highbar],newHigh,Time[pr_lowbar],newLow,color_HL.HH,LineTick_HL.HH);
      drawtext("HL"+Number,"HL",HL_Color,Time[pr_lowbar],newLow-TextShift*Point*Q,font_HL.HH);
     drawtext("HH"+Number,"HH",HH_Color,Time[highbar],newHigh+TextShift*Point*Q,font_HL.HH);
       drawtext("HLM"+Number,DoubleToStr(Ma_Angle(pr_lowbar),2),HL_Color,Time[pr_lowbar],newLow-MA_AngleTextShift*Point*Q,font_HL.HH);
     drawtext("HHM"+Number,DoubleToStr(Ma_Angle(highbar),2),HH_Color,Time[highbar],newHigh+MA_AngleTextShift*Point*Q,font_HL.HH);
     }
    if(newHigh<PreviousHigh&&newLow>PreviousLow&&Draw_HL.LH){
     
     drawtrend("HL.LH"+Number,Time[highbar],newHigh,Time[pr_lowbar],newLow,color_HL.LH,LineTick_HL.LH);
     drawtext("HL"+Number,"HL",HL_Color,Time[pr_lowbar],newLow-TextShift*Point*Q,font_HL.LH);
     drawtext("LH"+Number,"LH",LH_Color,Time[highbar],newHigh+TextShift*Point*Q,font_HL.LH);
     drawtext("HLM"+Number,DoubleToStr(Ma_Angle(pr_lowbar),2),HL_Color,Time[pr_lowbar],newLow-MA_AngleTextShift*Point*Q,font_HL.LH);
     drawtext("LHM"+Number,DoubleToStr(Ma_Angle(highbar),2),LH_Color,Time[highbar],newHigh+MA_AngleTextShift*Point*Q,font_HL.LH);
     }
   }
   
  }
  initialized=true;

  return(0);
}
//-----------------------------------------------------------------+

double Ma_Angle(int i){
 double MA=iCustom(Symbol(),0,"MA_Angle",0,i);
 return(MA);
}

//-----------------------------------------------------------------+

int LastSignalType(int i){
 for(int j=i+1;j<Bars;j++){
  if(Maxs[j]==High[j]&&Mins[j]!=Low[j])return(-1);
  if(Mins[j]==Low[j]&&Maxs[j]!=High[j])return(1);
 }
return(0);
}

//-----------------------------------------------------------------+

void drawtext(string name,string text, color _Color,datetime Time1,double Price1,int TextSize)
 {
  if(ObjectFind(name) == -1)
   {
    ObjectCreate(name, OBJ_TEXT,0,Time1, Price1);
    ObjectSetText(name, text, TextSize, "Arial Bold", _Color);
   }
   if(ObjectGet(name,OBJPROP_PRICE1)!=Price1)
    {
    ObjectDelete(name);
    drawtext(name,text,_Color,Time1,Price1,TextSize);
    }
 } 
//-----------------------------------------------------------------+ 
 
void drawtrend(string name,datetime Time1,double Price1,datetime Time2,double Price2,color LineColor,int Width)
 {
  if(ObjectFind(name) == -1)
    {
     ObjectCreate(name, OBJ_TREND, 0, Time1,Price1,Time2,Price2);
     ObjectSet(name, OBJPROP_COLOR, LineColor);
     ObjectSet(name, OBJPROP_WIDTH, Width);
     ObjectSet(name,OBJPROP_RAY,false);
      Number++;
   
    }
  if(ObjectGet(name,OBJPROP_PRICE1)!=Price1||ObjectGet(name,OBJPROP_PRICE2)!=Price2)
   {
    ObjectDelete(name);
     drawtrend(name,Time1,Price1,Time2,Price2,LineColor,Width);
   }
 } 
 
//-----------------------------------------------------------------+ 
void Check(int offset)
{
   double o = Open[offset];
   double h = High[offset];
   double l = Low[offset];
   double c = Close[offset];

   if (c < o)
   {
      CheckPrice(offset, h);
      CheckPrice(offset, l);
   }
   else
   {
      CheckPrice(offset, l);
      CheckPrice(offset, h);
   }
}
//-----------------------------------------------------------------+
void CheckPrice(int offset, double p)
{
   if (!Inited)
   {
      CheckInit(offset, p);
      Inited = true;
   }
   else
   {
      if (Direction[offset] == UP) CheckUp(offset, p);
      else if (Direction[offset] == DN) CheckDn(offset, p);
   }
}
//-----------------------------------------------------------------+
void CheckInit(int offset, double c)
{
   MaxTime[offset] = Time[offset];
   MinTime[offset] = Time[offset];
   
   Maxs[offset] = c;
   Mins[offset] = c;
      
   Direction[offset] = UP;
}
//-----------------------------------------------------------------+
void CheckUp(int offset, double c)
{
   int lastOffset = iBarShift(symbol, 0, MaxTime[offset]);
   if (Maxs[lastOffset] == EMPTY_VALUE)
   {
      Maxs[lastOffset] = High[lastOffset];
   }
   
   if (c > Maxs[lastOffset])
   {
      Maxs[lastOffset] = EMPTY_VALUE;
      Maxs[offset] = c;
      MaxTime[offset] = Time[offset];
      lastOffset = offset;
   }
   
   if (c*(1 + ChannelPercent/100.0) < Maxs[lastOffset])
   {
      Direction[offset] = DN;
      
      Mins[offset] = c;
      MinTime[offset] = Time[offset];
   }
}
//-----------------------------------------------------------------+

void CheckDn(int offset, double c)
{
   int lastOffset = iBarShift(symbol, 0, MinTime[offset]);
   if (Mins[lastOffset] == EMPTY_VALUE)
   {
      Mins[lastOffset] = Low[lastOffset];
   }
   
   if (c < Mins[lastOffset])
   {
      Mins[lastOffset] = EMPTY_VALUE;
      Mins[offset] = c;
      MinTime[offset] = Time[offset];
      lastOffset = offset;
   }
   
   if (c*(1 - ChannelPercent/100.0) > Mins[lastOffset])
   {
      Direction[offset] = UP;

      Maxs[offset] = c;
      MaxTime[offset] = Time[offset];
   }
}

//-----------------------------------------------------------------+